#include "sys_config.h"
#if PRODUCT_SY
#include "sys_processor.h"
#include "UWater_eeprom_driver.h"
#include "UWater_rtcc_app.h"
#include "UWater_power_app.h"
#include "UWater_gp22_app.h"
#include "UWater_pt_app.h" 
#include "UWater_DataTools_App.h"
#include "UWater_SY_Store_App.h"
#include "SOE.h"
#include "UWater_frame_func_ReplyNB.h"
#include "UWater_frame_func_ReplySYNB.h"


static STRUCT_FRAME_SY  frame_struct_SY; //ԼϢ
static u8 *new_message_data_rev_sy; 
static u8 up_deal_stat_sy = UP_DEAL_S0;

static u8 s_sy_eep_complete=0;
static u8 task_complete_sy = PTL_PACK_BUSY;
static u8 g_frame_temp_send_buf_sy[UP_BUF_SIZE];	//ݲֻ
static u16 g_frame_temp_len_sy=0;

static u8 *temp_send_start_p;
static u8 *temp_send_end_p;
static u8 *temp_send_end_p1;
static u8 temp_check_addr[7];

static u8 upload_serial_num_sy=0;

static u8 temp_upload_step=0;
static u8 upload_frame_retry_times = 0;

//ϱݻȡ
static TYP_STATE_SY upload_frame_stat_sy=SY_STATE_S0;
static u8 task_complete_upload_sy = PTL_PACK_BUSY; 
static u8 task_complete_warning_sy = PTL_PACK_BUSY; 
static u8 SY_CircleUploadPackets=0; //Ҫϱܰ
static u8 SY_CircleThisPacketNum=0;//ǰ
static u8 SY_CircleThisUploadPacket_Index=0;//ǰҪϱλ
static u8 SY_CiecleThisUploadPacket_Cnt=0;//ǰҪϱݰ
static u8 SY_CircleUploadBuf[400];//10+16x24=394//ϱݻ
static u16 SY_UploadDataLen=0;
static STRUCT_FRAME_SY temp_struct_upload_SY;
//ϱݻȡ
static TYP_STATE_SY step_UploadWarningSY = SY_STATE_S0;
static u8* temp_warning_start_p;
static u8*	temp_warning_end_p;

//ˮƽ̨ݹԼ
//ϴݣ101Ӧ1  ϱδݡˮ״̬Ϣ
void frame_func_reply_SYNB_UploadFrozenData(void)
{
    task_complete_sy = PTL_PACK_FAIL;//ϱӦ֡,ش,ƲӦ
}
//ϱ(102,Ӧ2)   ϱڲɼ
void frame_func_reply_SYNB_UploadCycleData(void)
{
	if(*(new_message_data_rev_sy + 14) == upload_serial_num_sy) //жкǷȷ
	{
		if(*(new_message_data_rev_sy + 19) == 0) //ϱǷɹ
		{
			FrameSetMsgApp(MsgShenYang_NbUplaod_AckOk);
		}
	}
	task_complete_sy = PTL_PACK_FAIL;//ϱӦ֡,ش,ƲӦ
}
//ͻϴ(103,Ӧ3)   ڷȼΪ1ı¼ʱʱϴ
void frame_func_reply_SYNB_SuddenAlarmUpload(void)
{
	if(*(new_message_data_rev_sy + 14) == upload_serial_num_sy) //жкǷȷ
	{
		if(*(new_message_data_rev_sy + 19) == 0) //ϱǷɹ
		{
			FrameSetMsgApp(MsgShenYang_NbUplaod_AckOk);
		}
	}
  task_complete_sy = PTL_PACK_FAIL;//ϱӦ֡,ش,ƲӦ
}

//ݲѯ(8,Ӧ108)  ѯնݡ궳ݡ¶
void frame_func_reply_SYNB_ACK_FrozenDataQuery(void)
{
	static u8 num_get,num_to_get,num_to_read,totalnum,totalPackts,curPackt,send_totalPackts;
	static u8 temp_all_num=0;
	static u8 check_num=0;
	static UNION_SY_STORE_FROZEN temp_read_frozen_data;//ݶȡ
	static u16 temp_frozen_addr=EEP_ADDR_SY_STORE_FROZEN_DAILY;
	
	switch(up_deal_stat_sy)
	{
		case UP_DEAL_S0:
		{
			 
			temp_send_start_p = g_frame_temp_send_buf_sy;
			temp_send_end_p = g_frame_temp_send_buf_sy;
			temp_send_end_p1 = g_frame_temp_send_buf_sy;
			if(*(new_message_data_rev_sy + 19) == 0)//
			{
				num_to_read = get_SY_StorePara(SY_StoreCurIndex_Daily);//նᵱǰ洢ָ
				temp_all_num = 7;//ȡ7
				temp_frozen_addr=EEP_ADDR_SY_STORE_FROZEN_DAILY;
			}
			else if(*(new_message_data_rev_sy + 19) == 1)//
			{
				num_to_read = get_SY_StorePara(SY_StoreCurIndex_Month);
				temp_all_num = 18;//18
				temp_frozen_addr=EEP_ADDR_SY_STORE_FROZEN_MONTH;
			}
			else if(*(new_message_data_rev_sy + 19) == 2)//
			{
				num_to_read = get_SY_StorePara(SY_StoreCurIndex_Year);
				temp_all_num = 6;//6
				temp_frozen_addr=EEP_ADDR_SY_STORE_FROZEN_YEAR;
			}
			totalnum = 0;
			num_get = 0;
			num_to_get  = *(new_message_data_rev_sy + 20);//Ҫȡ
			totalPackts = *(new_message_data_rev_sy + 21);//ܰ
			curPackt    = *(new_message_data_rev_sy + 22);//ǰ
			*temp_send_end_p++ = 0;//ܰ
			*temp_send_end_p++ = 0;//صǰ
			*temp_send_end_p++ = 0;//
			up_deal_stat_sy = UP_DEAL_S1;
		}
		break;
		case UP_DEAL_S1:
		{
		   if(totalnum >= temp_all_num)//ȡtemp_all_num
           {
			    send_totalPackts = totalPackts;
                up_deal_stat_sy = UP_DEAL_S3;
                break;
           }
           if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
           {
                if(num_to_read > temp_all_num) //ָֹܷ
                {
                    num_to_read = temp_all_num;
                }
                if(num_to_read == 0)
                {
                    num_to_read = temp_all_num;
                }
				totalnum++;
                num_to_read--;
                EepRead(temp_frozen_addr + num_to_read*STORE_SIZE_DATA_FROZEN, &temp_read_frozen_data.data_buf[0], STORE_SIZE_DATA_FROZEN, &s_sy_eep_complete);
                up_deal_stat_sy = UP_DEAL_S2;
		   }
		}
		break;
		case UP_DEAL_S2:
		{
			 if(TASK_IDLE == EepIfIdle())//
             {
				check_num = 0;
				for(int i = 0; i<(STORE_SIZE_DATA_FROZEN-1); i++)
				{
					check_num += temp_read_frozen_data.data_buf[i];
				}
				if(check_num == temp_read_frozen_data.Data.CheckSum)
				{
					temp_read_frozen_data.Data.FrozenDataTime.s.year  = BCD2HEX(temp_read_frozen_data.Data.FrozenDataTime.s.year);
					temp_read_frozen_data.Data.FrozenDataTime.s.month = BCD2HEX(temp_read_frozen_data.Data.FrozenDataTime.s.month);
					temp_read_frozen_data.Data.FrozenDataTime.s.day   = BCD2HEX(temp_read_frozen_data.Data.FrozenDataTime.s.day);
					temp_read_frozen_data.Data.FrozenDataTime.s.hour  = BCD2HEX(temp_read_frozen_data.Data.FrozenDataTime.s.hour);
					temp_read_frozen_data.Data.FrozenDataTime.s.minute= BCD2HEX(temp_read_frozen_data.Data.FrozenDataTime.s.minute);
					temp_read_frozen_data.Data.FrozenDataTime.s.second= BCD2HEX(temp_read_frozen_data.Data.FrozenDataTime.s.second);
					
					num_get++;
					if(num_get >= num_to_get)//ﵽҪȡ
					{
						for(int i = 0; i<(STORE_SIZE_DATA_FROZEN-2); i++)
						{
							*temp_send_end_p++ = temp_read_frozen_data.data_buf[i];
						}
						up_deal_stat_sy = UP_DEAL_S3;
						break;
					}
					else
					{
					    if(curPackt==1)
						{
							if(num_get<=9)//9ݣʼֳ
							{
								for(int i = 0; i<(STORE_SIZE_DATA_FROZEN-2); i++)
								{
									*temp_send_end_p++ = temp_read_frozen_data.data_buf[i];
								}
								totalPackts =1;
							}
							else
							{
								totalPackts = 2;//ܰΪ2
								if(num_get>0)
								{
									num_get--;
								}
								up_deal_stat_sy = UP_DEAL_S3;
								break;
							}
						}
						else if(curPackt==2)
						{
							if(num_get>9)//9ݣʼֳ
							{
								for(int i = 0; i<(STORE_SIZE_DATA_FROZEN-2); i++)
								{
									*temp_send_end_p++ = temp_read_frozen_data.data_buf[i];
								}
							}
						}
						else
						{
							totalPackts = 0;
							up_deal_stat_sy = UP_DEAL_S3;
							break;
						}
					}
				}
                up_deal_stat_sy = UP_DEAL_S1;
            }
		}
		break;
		case UP_DEAL_S3:
		{
			send_totalPackts = totalPackts;
			*temp_send_end_p1++ = send_totalPackts;//ܰ
			*temp_send_end_p1++ = curPackt;//ǰ
			if(num_get>9)
			{
				num_get = num_get - 9;
			}
			*temp_send_end_p1++ = num_get;//
			
			g_frame_temp_len_sy = (temp_send_end_p - temp_send_start_p);//Ҫݵĳ
			up_deal_stat_sy = UP_DEAL_S0;
			task_complete_sy = PTL_PACK_SUCCESS;  
		}
		break;
		default:
		{
			up_deal_stat_sy  = UP_DEAL_S0;
			task_complete_sy = PTL_PACK_FAIL;  
		}
		break;
	}
}
 //ݲѯ(9,Ӧ109) 
void frame_func_reply_SYNB_ACK_CycleDataQuery(void)
{
	static u8 temp_data_cnt=0;//Ҫȡ
	static u8 temp_packet_cnt=0;//ܰ
	static u8 curPacket;
	static u8 packet_index_buf[6];
	static u8 curPacketIndex=0;//Ҫȡ
	u8 readDays=0;//Ҫȡ
	
	switch(up_deal_stat_sy)
	{
		case UP_DEAL_S0:
		{
			g_frame_temp_len_sy = 0;
			temp_send_start_p = g_frame_temp_send_buf_sy;
			temp_send_end_p = g_frame_temp_send_buf_sy;
			readDays = *(new_message_data_rev_sy + 19); //ѯ
			curPacket = *(new_message_data_rev_sy + 21);//ǰ

			temp_packet_cnt = getSY_CircleDataPackets(readDays, packet_index_buf);//ȡܰͰ
			*temp_send_end_p++ = temp_packet_cnt;//ܰ
			//ǰ
			if((curPacket > temp_packet_cnt)||(curPacket == 0))//ҪȡĵǰЧ
			{
				*temp_send_end_p++ = 0;
				up_deal_stat_sy = UP_DEAL_S2;
			}
			else
			{
				*temp_send_end_p++ = curPacket;
				up_deal_stat_sy = UP_DEAL_S1;
			}
		}
		break;
		case UP_DEAL_S1:
		{
		   if(TASK_IDLE == EepIfIdle())
			{	
				DateTime temp_time;
				curPacketIndex = packet_index_buf[curPacket-1];
				//
				temp_data_cnt = SY_GetCircleReadStartEnd(curPacketIndex,1) - SY_GetCircleReadStartEnd(curPacketIndex,0);
				//ʼʱ
				SY_GetCircleDateTime(&temp_time,curPacketIndex, 1);//ʼʱ
				*temp_send_end_p++ = BCD2HEX(temp_time.s.year);//
				*temp_send_end_p++ = BCD2HEX(temp_time.s.month);//
				*temp_send_end_p++ = BCD2HEX(temp_time.s.day);//
				*temp_send_end_p++ = BCD2HEX(temp_time.s.hour); //ʱ
				*temp_send_end_p++ = BCD2HEX(temp_time.s.minute);//
				*temp_send_end_p++ = BCD2HEX(temp_time.s.second);//
				//ʱ
				*temp_send_end_p++ = 6;//30
				//
				*temp_send_end_p++ = temp_data_cnt;
				//ȡ
				u16 temp_ee_addr=0;
				temp_ee_addr = EEP_ADDR_SY_STORE_CIRCLE + curPacketIndex*16*24 + SY_GetCircleReadStartEnd(curPacketIndex,0)*16;
				EepRead(temp_ee_addr, temp_send_end_p, 16*temp_data_cnt, &s_sy_eep_complete);
				temp_send_end_p += 16*temp_data_cnt;
				up_deal_stat_sy = UP_DEAL_S2;
			}
		}
		break;
		case UP_DEAL_S2:
		{
			if(TASK_IDLE == EepIfIdle())//
			{
				g_frame_temp_len_sy = (temp_send_end_p - temp_send_start_p);//Ҫݵĳ
				up_deal_stat_sy  = UP_DEAL_S0;
				task_complete_sy = PTL_PACK_SUCCESS;  
			}
		}
		break;
		default:
		{
			up_deal_stat_sy  = UP_DEAL_S0;
			task_complete_sy = PTL_PACK_FAIL;  
		}
		break;
	}
}

//ʷݲѯ10Ӧ110   ѯʷ
void frame_func_reply_SYNB_ACK_AlarmHistoryDataQuery(void)
{
	static u8 *new_message_data_rev_ies; 
	static u8 num_get,num_to_get,num_to_read,totalnum;
    static mtype16_ temp_soe_type;
    static ONE_SOE soe_event_read;
    static DateTime_noweek start_time;
    static DateTime_noweek end_time;
	static u8 *temp_alarm_cnt;
	static u8 *temp_all_packets_p;
	static u8 all_packets, cur_packet;
	
    switch(up_deal_stat_sy)
    {
        case UP_DEAL_S0:
        {
			DateTime tempDataTime;
			 
			new_message_data_rev_ies = (new_message_data_rev_sy + 19);
			temp_send_start_p = g_frame_temp_send_buf_sy;
			temp_send_end_p = g_frame_temp_send_buf_sy;
			temp_all_packets_p = g_frame_temp_send_buf_sy;
            totalnum = 0;
            num_get = 0;
			RtccGetDateTime(&tempDataTime);//ȡǰʱ
            num_to_read = Sys_data_object.P4.Point_SOE_write;
			temp_soe_type.to_uint16 = SOE_ALL_TYPE;
			start_time = getBackDateTimeNoWeek(*(new_message_data_rev_ies + 0));//ȡʼʱ
			all_packets = *(new_message_data_rev_ies + 1);//ܰ
			cur_packet = *(new_message_data_rev_ies + 2);//ǰ,ֵ 4 (7*25=175ֽһ,4100)
			//ʱ
            end_time.s.year   = tempDataTime.s.year;					
            end_time.s.month  = tempDataTime.s.month;
            end_time.s.day    = tempDataTime.s.day;
            end_time.s.hour   = tempDataTime.s.hour;
            end_time.s.minute = tempDataTime.s.minute;
            end_time.s.second = tempDataTime.s.second;
			//ȡ
			if((0 == cur_packet)||(cur_packet > 4))
			{
				up_deal_stat_sy = UP_DEAL_S3;
			}
			num_to_get = 25;//25һְ
			{
				*temp_send_end_p++ = all_packets;//ܰ(վλ)
				*temp_send_end_p++ = cur_packet;//ǰ
				temp_alarm_cnt = temp_send_end_p++; //Ҫ
				up_deal_stat_sy = UP_DEAL_S1;
			}
       }
       break;
	   
       case UP_DEAL_S1://ȡһSOE
       {
           if(totalnum >= TOTAL_NUM_SOE)//ܹTOTAL_NUM_SOE  ǿ˳ٶ
           {
				all_packets = (num_get/25);
				if(num_get%25)
				{
					all_packets++;
				}
				*temp_all_packets_p = all_packets;
                up_deal_stat_sy = UP_DEAL_S3;
                break;
           }
           if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
           {
                totalnum++;
                if(num_to_read > TOTAL_NUM_SOE) //ָֹܷ
                {
                    num_to_read = TOTAL_NUM_SOE;
                }
                if(num_to_read == 0)
                {
                    num_to_read = TOTAL_NUM_SOE;
                }
                num_to_read--;
                EepRead(EEP_ADDR_SOE_BASE + (u16)num_to_read*LENGTH_ONE_SOE,(u8*)&soe_event_read,LENGTH_ONE_SOE, &s_sy_eep_complete);
				up_deal_stat_sy = UP_DEAL_S2;
           }
        }
        break;
		
        case UP_DEAL_S2:
        {
             if(TASK_IDLE == EepIfIdle())//
             {
                 if(TRUE == Check_One_Soe(temp_soe_type.to_uint16,&start_time,&end_time,&soe_event_read))//⵽һЧSOE
                 {
					 num_get++;
					 if((num_get > (cur_packet-1)*25)&&(num_get < (cur_packet*num_to_get)))//,Ҫȡڶʹӵ26ʼݸ50
					 {
						 *temp_send_end_p++ = soe_event_read.soe_type-1000;
						 *temp_send_end_p++ = BCD2HEX(soe_event_read.soe_time.s.year);
						 *temp_send_end_p++ = BCD2HEX(soe_event_read.soe_time.s.month);
						 *temp_send_end_p++ = BCD2HEX(soe_event_read.soe_time.s.day);
						 *temp_send_end_p++ = BCD2HEX(soe_event_read.soe_time.s.hour);
						 *temp_send_end_p++ = BCD2HEX(soe_event_read.soe_time.s.minute);
						 *temp_send_end_p++ = BCD2HEX(soe_event_read.soe_time.s.second);
					 }
                 }
                 up_deal_stat_sy = UP_DEAL_S1;
            }
        }
        break;
		
        case UP_DEAL_S3:
        {
			*temp_alarm_cnt = ((g_frame_temp_len_sy-3)/7); //㱨Ϣ
			g_frame_temp_len_sy = (temp_send_end_p - temp_send_start_p);//Ҫݵĳ
			up_deal_stat_sy = UP_DEAL_S0;
			task_complete_sy = PTL_PACK_SUCCESS;  
        }
        break;
		
        default:
        {
            up_deal_stat_sy  = UP_DEAL_S0;
			task_complete_sy = PTL_PACK_FAIL;  
        }
        break;
    }
}
     
//(51,Ӧ151)   նݡʷݡ
void frame_func_reply_SYNB_ACK_ClearAllData(void)
{
	temp_send_start_p = g_frame_temp_send_buf_sy;
	temp_send_end_p = g_frame_temp_send_buf_sy;
	
	*temp_send_end_p++ = *(new_message_data_rev_sy + 19); 
	*temp_send_end_p++ = *(new_message_data_rev_sy + 20);
	*temp_send_end_p++ = *(new_message_data_rev_sy + 21);
	if(*(new_message_data_rev_sy + 19) == 1) //ն
	{
		*temp_send_end_p++ = 1; //0 1ɹ 2ʧ
		FrameSetMsgApp(MsgShenYang_FrozenClear);	
	}
	
	if(*(new_message_data_rev_sy + 20) == 1) //ձ
	{
		*temp_send_end_p++ = 1; //0 1ɹ 2ʧ
		FrameSetMsgApp(MsgShenYang_WarningClear);
	}
	
	if(*(new_message_data_rev_sy + 21) == 1) //
	{
		*temp_send_end_p++ = 1; //0 1ɹ 2ʧ
		FrameSetMsgApp(MsgShenYang_CircleClear);
	}
	
	g_frame_temp_len_sy = 3;
	task_complete_sy = PTL_PACK_SUCCESS;
}
//ָ(52,Ӧ152)
void frame_func_reply_SYNB_ACK_RestoreFactorySetting(void)
{
	temp_send_start_p = g_frame_temp_send_buf_sy;
	temp_send_end_p = g_frame_temp_send_buf_sy;
	
	*temp_send_end_p++ = *(new_message_data_rev_sy + 19); 
	*temp_send_end_p++ = *(new_message_data_rev_sy + 20); 
	if(*(new_message_data_rev_sy + 20) == 1) //ָ
	{
		FrameSetMsgApp(MsgShenYang_FactorySettingAndReset);
	}
	else
	{
		if(*(new_message_data_rev_sy + 19) == 1) //
		{
			FrameSetMsgApp(MsgShenYang_SysReset);
		}
	}
	g_frame_temp_len_sy = 2;
	
	task_complete_sy = PTL_PACK_SUCCESS;
}
//ָ(71,Ӧ171)  ɳжıģɳ
void frame_func_reply_SYNB_DebugInstruction(void)
{
	g_frame_temp_len_sy = 0;
	task_complete_sy = PTL_PACK_SUCCESS;
}
/**
5ˮ
˱TLVʽͬʱɱģID(Tag)Ķ2ͬTagӦݳҲͬ
ģ
**/
//ˮӦƽ̨Լ
//ã6Ӧ106   ϴʱ䡢طš
void frame_func_reply_SYNB_ACK_ParameterSetting(void) 
{
	static u8 tlv_para_cnt=0;//ҪõĲ
    switch(up_deal_stat_sy)
    {
        case UP_DEAL_S0:
        {
			u8 temp_tag=0;
			u8 temp_len=0;
			u8 temp_value[32];
			u8 *temp_rev_p;
			
			 
			temp_rev_p = (new_message_data_rev_sy + 19);
			temp_send_start_p = g_frame_temp_send_buf_sy;
			temp_send_end_p = g_frame_temp_send_buf_sy;
			tlv_para_cnt = *temp_rev_p++; //ҪõĲ
			if(tlv_para_cnt <= TLV_STR_BUF_LEN)
			{
				*temp_send_end_p++ = tlv_para_cnt;
				for(int i=0; i<tlv_para_cnt; i++)
				{
					temp_tag = *temp_rev_p++;
					temp_len = *temp_rev_p++;
					*temp_send_end_p++ = temp_tag;
					*temp_send_end_p++ = temp_len;
					for(int j=0; j<temp_len; j++)
					{
						temp_value[j] = *temp_rev_p++;
						*temp_send_end_p++ = temp_value[j];
					}
					if(SUCCESS_IES == SetTLVData(temp_tag, temp_len, temp_value))
					{
						*temp_send_end_p++ = 0;//ɹ
					}
					else
					{
						*temp_send_end_p++ = 1;//ʧ
					}
				}
			}
			else
			{
				tlv_para_cnt = 0;
			}
			g_frame_temp_len_sy = (temp_send_end_p - temp_send_start_p);//Ҫݵĳ
			task_complete_sy = PTL_PACK_SUCCESS;
			up_deal_stat_sy  = UP_DEAL_S0;
		}		
		break;

        default:
        {
            up_deal_stat_sy  = UP_DEAL_S0;
            task_complete_sy = PTL_PACK_FAIL;
        }
        break;
    }
}

//ѯ7Ӧ107   ڷȼΪ1ı¼ʱʱϴ
void frame_func_reply_SYNB_ACK_ParameterQuery(void)
{		
	static u8 tlv_para_cnt=0;//ҪõĲ
	u8 temp_tag=0;
	u8 temp_value[32];
	u8 index=0;
	u8 *temp_rev_p;
		
	tlv_para_cnt = *(new_message_data_rev_sy + 19);//ҪѯĲ
	temp_send_start_p = g_frame_temp_send_buf_sy;
	temp_send_end_p = g_frame_temp_send_buf_sy;
	temp_rev_p = (new_message_data_rev_sy + 20); //tagʼλ
	if(tlv_para_cnt <= TLV_STR_BUF_LEN)
	{
		*temp_send_end_p++ = tlv_para_cnt;//ӦҪѯĲ
		for(int i=0; i<tlv_para_cnt; i++)
		{
			temp_tag = *temp_rev_p++;
			index = getTlvTagIndex(temp_tag);		 
			if(GetTLVData(temp_tag, TlvStrBuf[index].Len, temp_value) == SUCCESS_IES)
			{
				*temp_send_end_p++ = temp_tag;
				*temp_send_end_p++ = TlvStrBuf[index].Len;
				for(int j=0; j<TlvStrBuf[index].Len; j++)
				{
					*temp_send_end_p++ = temp_value[j];
				}
			}
		}
		g_frame_temp_len_sy = (temp_send_end_p - temp_send_start_p);
	}
	else
	{
		g_frame_temp_len_sy = 0;
		tlv_para_cnt = 0;
	}
    task_complete_sy = PTL_PACK_SUCCESS;
}
/**************************************************************************************
Լַ  
ˮַ6ֽBCD룬ΪÿһˮΨһĵַʽΪҴ루2λ+ݣ2λ+ˮţ8λ
ַΪAA AA AA AA AA AAʱΪ㲥ַ㲥ַֻӦڵԵͨѶС
***************************************************************************************/
u8 check_met_addr_SYNB(u8 *p_buf,u8 *des_buf)  
{
    u8 tmp_i;
	
	if(UP_SOURCE_IR == frame_get_datasource())  //ֹ֧ͨ㲥ַ
	{
		for(tmp_i=0;tmp_i < 6;tmp_i++)
		{
			if((0xAA != *(p_buf + 2 + tmp_i)) && (*(p_buf + 2 +tmp_i) != *(des_buf + tmp_i)))  //㲥ַͱַ
			{
				break;
			}			
		}	
	}
	else //Զ˲ֹ֧㲥ַ
	{
		for (tmp_i = 0; tmp_i < 6; tmp_i++)
		{
			if (*(p_buf + 2 +tmp_i) != *(des_buf + tmp_i))
			{
				break;
			}
		}
	}
	
	if(tmp_i >= 6)	
	{
		return SUCCESS_IES;
	}
	return ERROR_IES;
}
//NBԼ
u8 crack_frame_SY(u16 frame_lenth,u8 *frame_buffer)
{
    u16 tmp_i = 0;
    u16 tmp_j = 0;
    u8 tmp_check = 0;
    for (tmp_i = 0; tmp_i < frame_lenth; tmp_i++)
    {
        if (FM_HEAD_MARK == *(frame_buffer + tmp_i))
        {
            if (MET_TYPE_SY == *(frame_buffer + tmp_i + 1))
            {
                    frame_struct_SY.head_site = tmp_i; //¼֡ͷ
                    frame_struct_SY.sta  = *(frame_buffer + tmp_i + 16);//״̬֣bit0Ϊ1ʱʾܣ01Hʾܣbit1Ϊ1ʱʾϴbitλԤ
                    frame_struct_SY.len.data_buf[0] = *(frame_buffer + tmp_i + 17);//ݳ,ԼݳΪ2ֽڣֽǰֽں
				    frame_struct_SY.len.data_buf[1] = *(frame_buffer + tmp_i + 18);
					frame_struct_SY.end_site = frame_struct_SY.head_site + frame_struct_SY.len.datas + 20;
                    frame_struct_SY.check_len = frame_struct_SY.end_site - frame_struct_SY.head_site - 1;
                    frame_struct_SY.serial_num0 = *(frame_buffer + tmp_i + 14);  //кţӦʹ
	
                    //֡ǷЧ
                    if ((frame_struct_SY.end_site < frame_lenth) && (FM_END_MARK == *(frame_buffer + frame_struct_SY.end_site)))
                    {
                        frame_struct_SY.ctrl = *(frame_buffer + frame_struct_SY.head_site + 15);
						new_message_data_rev_sy = frame_buffer + frame_struct_SY.head_site;	
						for (tmp_j = 0; tmp_j < 6; tmp_j++) //Լַֻ6ֽڵBCD
						{
							temp_check_addr[tmp_j] = Sys_data_object.P1.met_addr[tmp_j];
						}
                        //У
                        for (tmp_j = frame_struct_SY.head_site; tmp_j < (frame_struct_SY.end_site - 1); tmp_j++)
                        {
                            tmp_check += *(frame_buffer + tmp_j);
                        }
                        if (tmp_check == *(frame_buffer + frame_struct_SY.end_site - 1))
                        {
                            frame_struct_SY.sta &= 0xFD; //ʾϴbit1Ϊ1ʱʾϴ0ʾӦ															
                            frame_lenth = 0;
							if (ERROR_IES == check_met_addr_SYNB(frame_buffer + frame_struct_SY.head_site, temp_check_addr)) //ָĵַͱַǷͬͬ1ͬ0
                            {
                                return (ERROR_IES);
                            }
                            return  SUCCESS_IES;
                        }
                        
                    }             
            }
        }
    }
    return ERROR_IES;   
}
//Լ
u8 up_deal_code_sy(void)
{
    task_complete_sy = PTL_PACK_BUSY;
    switch(frame_struct_SY.ctrl)
    {
		case FM_UPLOAD_FROZEN_DATA_REPLY_CTRL://ݵϱӦ
		{
			frame_func_reply_SYNB_UploadFrozenData();
			frame_struct_SY.ack_ctrl = FM_UPLOAD_FROZEN_DATA_CTRL;
		}
		break;
		case FM_UPLOAD_CYCLE_DATA_REPLY_CTRL://ݵϱӦ
		{
			frame_func_reply_SYNB_UploadCycleData();
			frame_struct_SY.ack_ctrl = FM_UPLOAD_CYCLE_DATA_CTRL;
		}
		break;
		case FM_SUDDEN_ALARM_UPLOAD_REPLY_CTRL://ϢϱӦ
		{
			frame_func_reply_SYNB_SuddenAlarmUpload();
			frame_struct_SY.ack_ctrl = FM_SUDDEN_ALARM_UPLOAD_CTRL;
		}
		break;
		case FM_FROZEN_DATA_QUERY_CTRL://ݲѯ 
		{
			frame_func_reply_SYNB_ACK_FrozenDataQuery();
			frame_struct_SY.ack_ctrl = FM_FROZEN_DATA_QUERY_REPLY_CTRL;
		}
		break;
		case FM_CYCLE_DATA_QUERY_CTRL://ݲѯ
		{
			frame_func_reply_SYNB_ACK_CycleDataQuery();
			frame_struct_SY.ack_ctrl = FM_CYCLE_DATA_QUERY_REPLY_CTRL;
		}
		break;
		case FM_ALARM_HISTORY_DATA_QUERY_CTRL://Ϣѯ
		{
			frame_func_reply_SYNB_ACK_AlarmHistoryDataQuery();
			frame_struct_SY.ack_ctrl = FM_ALARM_HISTORY_DATA_QUERY_REPLY_CTRL;
		}
		break;
		case FM_CLEAR_ALL_DATA_CTRL://
		{
			frame_func_reply_SYNB_ACK_ClearAllData();
			frame_struct_SY.ack_ctrl = FM_CLEAR_ALL_DATA_REPLY_CTRL;
		}
		break;
		case FM_RESTORE_FACTORY_SETTING_CTRL:
		{
			frame_func_reply_SYNB_ACK_RestoreFactorySetting();
			frame_struct_SY.ack_ctrl = FM_RESTORE_FACTORY_SETTING_REPLY_CTRL;
		}
		break;
		case FM_DEBUG_INSTRUCTION_CTRL:
		{
			frame_func_reply_SYNB_DebugInstruction();
			frame_struct_SY.ack_ctrl = FM_DEBUG_INSTRUCTION_REPLY_CTRL;
		}
		break;
		case FM_PARAMENTER_SETTING_CTRL:
		{
			frame_func_reply_SYNB_ACK_ParameterSetting(); 
			frame_struct_SY.ack_ctrl = FM_PARAMENTER_SETTING_REPLY_CTRL;
		}
		break;
		case FM_PARAMENTER_QUERY_CTRL:
		{
			frame_func_reply_SYNB_ACK_ParameterQuery();
			frame_struct_SY.ack_ctrl = FM_PARAMENTER_QUERY_REPLY_CTRL;
		}
		break;
		
        default:
        {     
			up_deal_stat_sy  = UP_DEAL_S0;
			task_complete_sy = PTL_PACK_FAIL;           
        }
        break;
    }
    return task_complete_sy;
}
void Frame_ResetDealState_Shenyang(void)
{
	up_deal_stat_sy = UP_DEAL_S0;
}

void get_imei_and_signal_parameters(u8 *tmp_data_buf)
{
	u8 i = 0;
	u8 s_temp_data1 = 0;
	u8 temp_buf1[16];
	u8 temp_buf2[16];
	s16 s_temp_data=0;
	UNION_2U8TOU16 s_temp_singal;
	
	NbiotGetIMEI((char*)temp_buf1);	
	temp_buf2[0] = temp_buf1[0] - 0x30;	
	for(i=1;i<8;i++)
	{
		temp_buf2[i]  =  (temp_buf1[2*i]-0x30)&0x0F;
		temp_buf2[i] |= ((temp_buf1[2*i-1]-0x30)<<4)&0xF0;          
	}
	for(i=0;i<8;i++)
	{
	    *tmp_data_buf ++ = temp_buf2[7-i];
	}
	*tmp_data_buf ++ =0;
	*tmp_data_buf ++ =0;
	*tmp_data_buf ++ =0;
	NbiotGetRSRP(&s_temp_data);
	s_temp_singal.datas = (s_temp_data*0.1);
	s_temp_singal.datas = (~ s_temp_singal.datas) | 0x8000;
	*tmp_data_buf ++ = s_temp_singal.datas_map .data0 ;
	*tmp_data_buf ++ = s_temp_singal.datas_map .data1;
	
	NbiotGetSNR(&s_temp_data);  //ƽ̨δŴ102ֽз
	s_temp_data = s_temp_data*0.1;
	if(s_temp_data<0)
	{
		s_temp_singal.datas = (-s_temp_data);
		s_temp_singal.datas = (~s_temp_singal.datas) |0x8000;
		
	}
	else
    {
	    s_temp_singal.datas = s_temp_data;
	}
	*tmp_data_buf ++ = s_temp_singal.data_buf[0];
	*tmp_data_buf ++ = s_temp_singal.data_buf[1];
	
	NbiotGetECL(&s_temp_data);  
	s_temp_singal.datas = s_temp_data*0.1;
	*tmp_data_buf ++ = (u8)(s_temp_singal.datas);  //ԼECLҪһֽڣ012
	
	 NbiotGetCSQ(&s_temp_data1);  //ԼCSQϴ1ֽ
	*tmp_data_buf ++ = s_temp_data1;
}

//NBԼ֡
void Frame_ack_ShenYangBase(STRUCT_FRAME_SY temp_struct, u8* p_temp_buf, u16 p_temp_len, u8* p_send_buf, u16* p_send_len)
{
    u8 i = 0;
    u16 j = 0;
	UNION_2U8TOU16 frame_pack_len;
    p_send_buf[0] = 0xFE;  //ԼûҪǰ
    p_send_buf[1] = 0xFE;
    p_send_buf[2] = FM_HEAD_MARK; //ͷ68H
    p_send_buf[3] = MET_TYPE_SY; //Լ汾02H
      //ASCIIʽIMEI11ֽ(imeiʵ15)
      //źŲ6ֽ   //źǿ(RSRP),2ֽз
                       // (SNR),2ֽз
                       // ǵȼ1ֽ0,1,2
                        //ź(CSQ)1ֽ
     //ַ6ֽ
     //к1ֽ  Լ
     //1ֽ
     //ܰ汾1ֽ 01
     //򳤶2ֽ
     //Nֽ
     //У1ֽ
	 //β16H
	get_imei_and_signal_parameters(&p_send_buf[4]);  //18ֽ	
	for (i = 0; i < 6; i++)  //Լַ6ֽBCD
	{
		p_send_buf[21 + i] = Sys_data_object.P1.met_addr[i];
	}
	p_send_buf[27] = temp_struct.serial_num0;  //Ӧк
    p_send_buf[28] = temp_struct.ack_ctrl;
    p_send_buf[29] = temp_struct.sta;
	frame_pack_len.datas  = p_temp_len;
	p_send_buf[30] = frame_pack_len.datas_map .data0 ;//Լݳ2ֽڣֽǰֽں
	p_send_buf[31] = frame_pack_len.datas_map .data1 ;
	memcpy(&p_send_buf[32], p_temp_buf, p_temp_len);

	p_send_buf[32+frame_pack_len.datas]=0;
	for (j = 2; j < 32+frame_pack_len.datas; j++)
	{
		p_send_buf[32+frame_pack_len.datas] += p_send_buf[j];//У
	}           
	p_send_buf[33+frame_pack_len.datas] = FM_END_MARK; //֡
	*p_send_len = 34+frame_pack_len.datas;    
}
//NBԼӦ֡ʽ֡
void Sy_Frame_nb_read_ack(u8* p_send_buf, u16* p_send_len)
{
	Frame_ack_ShenYangBase(frame_struct_SY, g_frame_temp_send_buf_sy, g_frame_temp_len_sy, p_send_buf, p_send_len);
}

////////////////////////////////////////////////////////////////Ϊϱ//////////////////////////////
//NBԼϱ֡
void Sy_Frame_nb_upload(u8* p_send_buf, u16* p_send_len)
{
	Frame_ack_ShenYangBase(temp_struct_upload_SY, SY_CircleUploadBuf, SY_UploadDataLen, p_send_buf, p_send_len);
}

//ϴ֡
void Nb_SY_ReadWarningRecord(u8 *p_send_buf, u16 *p_send_len)
{
	static u8 num_get,num_to_read,totalnum;
    static mtype16_ temp_soe_type;
    static ONE_SOE soe_event_read;
    static DateTime_noweek start_time;
    static DateTime_noweek end_time;

    switch(step_UploadWarningSY)
    {
        case SY_STATE_S0:
        {
			DateTime tempDataTime;
			
			temp_warning_start_p = p_send_buf;
			temp_warning_end_p = p_send_buf;
			
			RtccGetDateTime(&tempDataTime);//ȡǰʱ
            num_to_read = Sys_data_object.P4.Point_SOE_write;
			temp_soe_type.to_uint16 = SOE_ALL_TYPE;
			//ʼʱ
			start_time.s.year   = tempDataTime.s.year;					
            start_time.s.month  = tempDataTime.s.month;
            start_time.s.day    = tempDataTime.s.day;
            start_time.s.hour   = 0x00;
            start_time.s.minute = 0x00;
            start_time.s.second = 0x00;
			//ʱ
            end_time.s.year   = tempDataTime.s.year;					
            end_time.s.month  = tempDataTime.s.month;
            end_time.s.day    = tempDataTime.s.day;
            end_time.s.hour   = tempDataTime.s.hour;
            end_time.s.minute = tempDataTime.s.minute;
            end_time.s.second = tempDataTime.s.second;
			//ȡ
            num_get = 0;	
			totalnum = 0;
			SY_UploadDataLen = 9;
			temp_warning_end_p += 9;
			step_UploadWarningSY = SY_STATE_S1;
       }
       break;
	   
       case SY_STATE_S1://ȡһSOE
       {
		   if(totalnum >= TOTAL_NUM_SOE)//ܹTOTAL_NUM_SOE  ǿ˳ٶ
           {
                step_UploadWarningSY = SY_STATE_S3;
                break;
           }
           if(TASK_IDLE == EepIfIdle())//洢ݵEEPROM
           {
                totalnum++;
                if(num_to_read > TOTAL_NUM_SOE) //ָֹܷ
                {
                    num_to_read = TOTAL_NUM_SOE;
                }
                if(num_to_read == 0)
                {
                    num_to_read = TOTAL_NUM_SOE;
                }
                num_to_read--;
                EepRead(EEP_ADDR_SOE_BASE + (u16)num_to_read*LENGTH_ONE_SOE,(u8*)&soe_event_read,LENGTH_ONE_SOE, &s_sy_eep_complete);
           }
           step_UploadWarningSY = SY_STATE_S2;
        }
        break;
		
        case SY_STATE_S2:
        {
             if(TASK_IDLE == EepIfIdle())//
             {
                 if(TRUE == Check_One_Soe(temp_soe_type.to_uint16,&start_time,&end_time,&soe_event_read))//⵽һЧSOE
                 {
					 *temp_warning_end_p++ = soe_event_read.soe_type-1000;
					 *temp_warning_end_p++ = BCD2HEX(soe_event_read.soe_time.s.year);
					 *temp_warning_end_p++ = BCD2HEX(soe_event_read.soe_time.s.month);
					 *temp_warning_end_p++ = BCD2HEX(soe_event_read.soe_time.s.day);
					 *temp_warning_end_p++ = BCD2HEX(soe_event_read.soe_time.s.hour);
					 *temp_warning_end_p++ = BCD2HEX(soe_event_read.soe_time.s.minute);
					 *temp_warning_end_p++ = BCD2HEX(soe_event_read.soe_time.s.second);                                       
                     num_get++;
                     if(num_get >= 20)//20
                     {
                         step_UploadWarningSY = SY_STATE_S3;
                         break;
                     }
                 }
                 step_UploadWarningSY = SY_STATE_S1;
            }
        }
        break;
		
        case SY_STATE_S3:
        {
			DateTime tempRtcc_time;
			RtccGetDateTime(&tempRtcc_time);;//ȡǰʱ
			// 3ֽ
			*temp_warning_start_p++ = BCD2HEX(tempRtcc_time.s.year);
			*temp_warning_start_p++ = BCD2HEX(tempRtcc_time.s.month);
			*temp_warning_start_p++ = BCD2HEX(tempRtcc_time.s.day);
			//ʱ 3ֽ
			*temp_warning_start_p++ = BCD2HEX(tempRtcc_time.s.hour); 
			*temp_warning_start_p++ = BCD2HEX(tempRtcc_time.s.minute);
			*temp_warning_start_p++ = BCD2HEX(tempRtcc_time.s.second);
			//״̬
			*temp_warning_start_p++ = getWaterState();
			//״̬
			*temp_warning_start_p++ = 0;//޷
			*temp_warning_start_p++ = ((SY_UploadDataLen-9)/7);//
				
			*p_send_len = temp_warning_end_p-temp_warning_start_p;
			
			task_complete_warning_sy = PTL_PACK_SUCCESS;  
			step_UploadWarningSY = SY_STATE_S0;
        }
        break;
		
        default:
        {
            step_UploadWarningSY  = SY_STATE_S0;
        }
        break;
    }
}

void GetUploadDataResetState_ShenYangUDP(void)
{
	upload_frame_stat_sy =SY_STATE_S0;
}
u8 GetUploadDataCheckIdle_ShenYangUDP(void)
{
	if(SY_STATE_S0 == upload_frame_stat_sy)
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}
u8 GetUploadDataCheckTask_ShenYangUDP(void)
{
	return task_complete_upload_sy;
}
	
void GetUploadDataMachine_ShenYangUDP(u8 data_step, u8* p_send_buf, u16* p_send_len)
{
	switch(upload_frame_stat_sy)
	{
		case SY_STATE_S0:
		{
			if(data_step == UPLOAD_FRAME_REQUEST_NEW)//ݰ
			{
				temp_upload_step = 0;
				upload_frame_retry_times = 0;
				upload_frame_stat_sy = SY_STATE_S1;
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_OK)//ͳɹ
			{
				if(temp_upload_step == SY_STATE_S2)//ǰݷͳɹ,
				{
					task_complete_upload_sy = PTL_PACK_FAIL;//
					upload_frame_stat_sy = SY_STATE_S0;
				}
				if(temp_upload_step == SY_STATE_S3)//ʷݷͳɹ,洢ѷλ,ȡһ
				{
					upload_frame_stat_sy = SY_STATE_S10;
				}
				if(temp_upload_step == SY_STATE_S4)//ݷͳɹ,
				{
					task_complete_upload_sy = PTL_PACK_FAIL;//
					upload_frame_stat_sy = SY_STATE_S0;
				}
				upload_frame_retry_times = 0;
				SystemClearUploadAgain();//ش0
			}
			else if(data_step == UPLOAD_FRAME_UPLOAD_RETRY)//·
			{
				upload_frame_stat_sy = SY_STATE_S21;
			}
			else if(data_step == UPLOAD_FRAME_ONLINE_FAIL) //ʧ
			{
				  if(UPLOAD_TYPE_FIX_TIME == GetEventUploadType()||
					(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType()))//ʱϴ
				{
					SystemAddUploadAgain();//ش
				}
				task_complete_upload_sy = PTL_PACK_FAIL;
				upload_frame_stat_sy = SY_STATE_S0;
			}
			else 
			{
				task_complete_upload_sy = PTL_PACK_FAIL;
				upload_frame_stat_sy = SY_STATE_S0;
			}
		}
		break;
		case SY_STATE_S1://ȡϱܰ
		{
			SY_CircleUploadPackets = getSY_CircleUploadPackets();//ϱܰ
			if(SY_CircleUploadPackets == 0)//ûд洢,ϱǰ
			{
				upload_frame_stat_sy = SY_STATE_S2;
			}
			else
			{
				SY_CircleThisPacketNum = 0;
				SY_CircleThisUploadPacket_Index = getSY_ThisCirclePacket_Index(SY_CircleThisPacketNum);//Ҫϱλ
				upload_frame_stat_sy = SY_STATE_S3;
			}
		}
		break;
		case SY_STATE_S2://ֻϱǰ
		{
			temp_upload_step = SY_STATE_S2;
			
			temp_struct_upload_SY.ack_ctrl = FM_UPLOAD_CYCLE_DATA_CTRL;
			temp_struct_upload_SY.sta = 0;
			upload_serial_num_sy++;//к
			temp_struct_upload_SY.serial_num0 = upload_serial_num_sy;
			
			SY_UploadDataLen = NB_SY_Frame_Upload_CurrentData(&SY_CircleUploadBuf[0]);//ȡݲ
			Sy_Frame_nb_upload(p_send_buf, p_send_len);//ϱ֡
			
			task_complete_upload_sy = PTL_PACK_SUCCESS;//
			upload_frame_stat_sy = SY_STATE_S0;
		}
		break;
		
		case SY_STATE_S3://ϱʷ:ϱλûȡ
		{
			SY_CiecleThisUploadPacket_Cnt = NB_SY_Frame_Upload_Data(SY_CircleThisUploadPacket_Index, &SY_CircleUploadBuf[10]);
			if(SY_CiecleThisUploadPacket_Cnt > 0)
			{
				temp_upload_step = SY_STATE_S3;
				
				DateTime tempRtcc_time;
				SY_CircleUploadBuf[0] = SY_CircleUploadPackets; //ܰ 1ֽ
				SY_CircleUploadBuf[1] = SY_CircleThisPacketNum+1; //ǰ 1ֽ
				SY_GetCircleDateTime(&tempRtcc_time, SY_CircleThisUploadPacket_Index, 0);
				 //ʼ 3ֽ
				SY_CircleUploadBuf[2] = BCD2HEX(tempRtcc_time.s.year);//BCDתhex
				SY_CircleUploadBuf[3] = BCD2HEX(tempRtcc_time.s.month);
				SY_CircleUploadBuf[4] = BCD2HEX(tempRtcc_time.s.day);
				//ʼʱ 3ֽ
				SY_CircleUploadBuf[5] = BCD2HEX(tempRtcc_time.s.hour); 
				SY_CircleUploadBuf[6] = BCD2HEX(tempRtcc_time.s.minute);
				SY_CircleUploadBuf[7] = BCD2HEX(tempRtcc_time.s.second);
				SY_CircleUploadBuf[8] = 6;  //6:ʾ30ӣ5x6ʱ1ֽ
				SY_CircleUploadBuf[9] = SY_CiecleThisUploadPacket_Cnt;  //1ֽ
				
				SY_UploadDataLen = 10 + 16*SY_CiecleThisUploadPacket_Cnt;//ݳ
				
				temp_struct_upload_SY.ack_ctrl = FM_UPLOAD_CYCLE_DATA_CTRL;
				temp_struct_upload_SY.sta = 0;
				upload_serial_num_sy++;//к
				temp_struct_upload_SY.serial_num0 = upload_serial_num_sy;
				Sy_Frame_nb_upload(p_send_buf, p_send_len);//ϱ֡
				
				task_complete_upload_sy = PTL_PACK_SUCCESS;//
				upload_frame_stat_sy = SY_STATE_S0;
			}
		}
		break;
		case SY_STATE_S4://ϴ
		{
			if(FrameCheckMsgApp(MsgShenYang_NbUploadWarningWithCircle))//жǷϱϢ
			{
				FrameClearMsgApp(MsgShenYang_NbUploadWarningWithCircle);
				step_UploadWarningSY = SY_STATE_S0;
				task_complete_warning_sy = PTL_PACK_BUSY;  
				upload_frame_stat_sy = SY_STATE_S5;
			}
			else
			{
				task_complete_upload_sy = PTL_PACK_FAIL;//ʧ
				upload_frame_stat_sy = SY_STATE_S0;
			}
		}
		break;
		
		case SY_STATE_S5://ϴ
		{
			Nb_SY_ReadWarningRecord(SY_CircleUploadBuf, &SY_UploadDataLen);
			if(task_complete_warning_sy == PTL_PACK_SUCCESS)
			{
				temp_struct_upload_SY.ack_ctrl = FM_SUDDEN_ALARM_UPLOAD_CTRL;
				temp_struct_upload_SY.sta = 0;
				upload_serial_num_sy++;//к
				temp_struct_upload_SY.serial_num0 = upload_serial_num_sy;
				Sy_Frame_nb_upload(p_send_buf, p_send_len);//ϱ֡
				
				temp_upload_step = SY_STATE_S4;
				
				task_complete_upload_sy = PTL_PACK_SUCCESS;//
				upload_frame_stat_sy = SY_STATE_S0;
			}
		}
		break;
		
		
		case SY_STATE_S10://ǰϱɹ,´洢ָ
		{
			if(ShenYang_CircleDataStore_ClearUploadIndex(SY_CircleThisUploadPacket_Index))
			{
				SY_CircleThisPacketNum ++;
				if(SY_CircleThisPacketNum < SY_CircleUploadPackets)
				{
					SY_CircleThisUploadPacket_Index = getSY_ThisCirclePacket_Index(SY_CircleThisPacketNum);//Ҫϱλ
					upload_frame_stat_sy = SY_STATE_S3;//ϱ
				}
				else
				{
					upload_frame_stat_sy = SY_STATE_S4;//ϱ,ʼϱϢ
				}
			}
		}
		break;
		case UP_DEAL_S21://
		{
			if(upload_frame_retry_times < 3) 
			{
				upload_frame_retry_times++;
				
				if(temp_upload_step == SY_STATE_S2)//ǰݷʧ,͵ǰ
				{
					upload_frame_stat_sy = SY_STATE_S2;
				}
				else if(temp_upload_step == SY_STATE_S3)//ʷݷʧ,͸ðʷ
				{
					upload_frame_stat_sy = SY_STATE_S3;
				}
				else if(temp_upload_step == SY_STATE_S4)//ݷʧ,ͱ
				{
					upload_frame_stat_sy = SY_STATE_S4;
				}
				else
				{
					task_complete_upload_sy = PTL_PACK_FAIL;
					upload_frame_stat_sy = SY_STATE_S0;
				}
			} 
			else//·ʧ3εĴ
			{
				if((UPLOAD_TYPE_FIX_TIME == GetEventUploadType())||
					(UPLOAD_TYPE_RETRY_AGAIN == GetEventUploadType()))//ʱϴ
				{
					if((temp_upload_step == SY_STATE_S2)||(temp_upload_step == SY_STATE_S3))//ϱ,ش
					{
						SystemAddUploadAgain();//ش
					}
				}
				task_complete_upload_sy = PTL_PACK_FAIL;
				upload_frame_stat_sy = SY_STATE_S0;
			}
		}
		break;
		
		default:
		{
			upload_frame_stat_sy = SY_STATE_S0;
			break;
		}
	}
}

/*******************************************************************************
 * @fun_name:NB_SS_Control_GetPara
 * @brief   :    
 * @param[in] :ȡϱز
 * @param[out]: None
 * @retval    : None
 * @other     :
 ******************************************************************************/
u8 NB_SS_Control_GetPara(NB_SS_ControlParaTypeDef paraType)
{
	return 0;
}
/*******************************************************************************
 * @fun_name:NB_SS_Control_SetPara
 * @param[in] :ϱز
 ******************************************************************************/
void NB_SS_Control_SetPara(NB_SS_ControlParaTypeDef paraType, u8 data)
{
    switch(paraType)
	{
	    case NB_HistroyReadIndex://ʷݵĶָ
		{
			Sys_data_object.P1.histroy_w = data;
			break;
		}
		case NB_UploadFailTimes://ʧܴ
		{
			SystemClearUploadAgain();
			Sys_data_object.P1.Supplemental_send_flag.datas = data;
			Sys_data_object.P3.ProductUpoadFailFlag = 0;
			break;
		}
		case NB_SS_FormatError://ϱݸʽ
		{
			break;
		}
		default:
			break;
	}
}

//Լݴ洢ֳʼ
void DataStoreInit(void)
{
	Quanzhou_Store_InitApp();
	ShenYang_Store_InitApp();
}
//Լݴ洢״̬
void DataStoreMachine(void)
{
	Quanzhou_Store_Machine();//ա¶ݴ洢
	ShenYang_Store_Machine();//ݴ洢
	ShenYang_SOE_Machine();//SOE¼洢
	ShenYang_TlvDataStoreMachine(); //
}
//Լݴ洢ж
u8 DataStoreIfIdle(void)
{
	if((QuanzhouStore_IfSleep() == TRUE) && (ShenYangStore_IfSleep() == TRUE))
	{
		return TRUE;
	}
	return FALSE;
}


#endif










